// PROGRAMME DE TEST, PORTAGE DU BUMP SOUS SDL.
// Auteur: Lepinay Laurent ( sigo )
// mail to: sigo@fleming.u-psud.fr

// A definir pr la compil linux.
#define LINUX_COMPIL

#include "SDL.h"
#include <math.h>
#include <stdio.h>

#ifndef LINUX_COMPIL
#include <windows.h> // pour exit()
#else
#include <unistd.h>
#endif

int RgbToInt( int r, int g, int b )
{
	return (r << 16) | (g << 8) | b;
}

//----------------------------------------------------------------------//
// loadpcx - Charge en memoire un fichier .PCX                          //
//  -    , ,     //
//----------------------------------------------------------------------//
int loadpcx(char *nomfich,unsigned long taille,int *image)
{
 unsigned char data, nb_octets;
 unsigned long index = 0;
 unsigned int  indexrle;
 FILE *fichpcx;

 if (!(fichpcx = fopen(nomfich, "rb"))) 
{
  exit(1);
 }

 fseek(fichpcx, 128, SEEK_SET);
	
 do {
  fread(&data, 1, 1, fichpcx);
  if ((data & 0xC0) == 0xC0)
 {
   nb_octets = (data & 0x3F);
   fread(&data,1,1,fichpcx);
   for (indexrle=1;indexrle<=nb_octets;indexrle++) 
    image[index++]= (data << 16) | (data << 8) | data ;
  }
  else image[index++] = (data << 16) | (data << 8) | data ;
 } while(index < taille);
	
 fclose(fichpcx);
 return 1;
}

int main( int argc, char* argv[] )
{
 // OLD BUMP PART
 int nEnvMap[256*256];

 // int image[800*600];
 // int *image=new int[800*600];
 int *image=(int*)malloc(800*600*sizeof(int));

 long xdisplay=800,ydisplay=600;

 int pal[256];
 int palpaint[256];
 long x, y, i;
 long dX, dY;
 long lX, lY;
 float scalex=1.2,scaley=0.8,dscalex=0.002,dscaley=0.002;
 float fTime=0.0f;

 // SDL data
 int bQuit = 0;
 SDL_Surface *buffer = NULL;
 SDL_Event event;


 if( SDL_Init(SDL_INIT_VIDEO) == -1 )
 {
#ifndef LINUX_COMPIL
  MessageBox( NULL, "Erreur1", "Erreur", MB_OK );
#endif
  return -1;
 }
	
 if( SDL_InitSubSystem(SDL_INIT_VIDEO) == -1 )
 {
#ifndef LINUX_COMPIL
  MessageBox( NULL, "Erreur2", "Erreur", MB_OK );
#endif
  return -1;
 }
	
 if( ! (buffer = SDL_SetVideoMode(800, 600, 32, SDL_DOUBLEBUF))  )
 {
#ifndef LINUX_COMPIL
  MessageBox( NULL, "Erreur3", "Erreur", MB_OK );
#endif
  return -1;
 }
	
 // Generation de l'environment map.
 // Elle va nous donner le niveau d'ullimination
 // a utiliser pour une orientation de pixel.
 // Cette table na pas besoin d'tre optimise.
 for( y = 0; y < 256; y++ )
 {
  for( x = 0; x < 256; x++ )
 {
   // Le calcul de distance au centre se fait par 
   // rapport au centre (128,128), il faut donc
   // changer de repre.
   nEnvMap[ x + 256*y ] = 
    255 - 255*sqrt((x-128)*(x-128)+(y-128)*(y-128))/
sqrt( 128*128 + 128*128 );
  }
 }

 // Gnration d'une palette qui va nous donner la couleur
 // a utiliser en fonction d'un niveau d'ullimination donn.
 for( i = 0; i < 64; i++ )
    pal[i] = 0;
 
 for( i = 64; i < 128; i++ )
  pal[i] = RgbToInt( 0, 0, (i-64)*4);
 for( i = 128; i < 256; i++ )
 pal[i] = RgbToInt( (i-128)*2, (i-128)*2, 255);

 for( i = 0; i < 64; i++ )
    palpaint[i] = 0;
 
 for( i = 64; i < 128; i++ )
  palpaint[i] = RgbToInt( (i-64)*4, (i-64)*0, (i-64)*0);
 for( i = 128; i < 256; i++ )
 palpaint[i] = RgbToInt( 255, (i-128)*2, (i-128)*2);

 // Ouverture de l'image qui va tre bumpe
 loadpcx("ksi.pcx",xdisplay*ydisplay,image);
	
 // lX = 160 + 80*cos(fTime += .1);
 // lY = 100 + 80*sin(fTime);

 lX = ((xdisplay/2) + (xdisplay/4)*cos(fTime += .05))*scalex;
 lY = ((ydisplay/2) + (ydisplay/4)*sin(fTime))*scaley;

 scalex=scalex+dscalex;
 scaley=scaley+dscaley;
 if(scalex>1.3)dscalex=0-dscalex;
 if(scalex<0.7)dscalex=0-dscalex;
 if(scaley>1.3)dscaley=0-dscaley;
 if(scaley<0.7)dscaley=0-dscaley;

 // Gnration du bump mapping.
 do
 {
  SDL_LockSurface(buffer);

  for( y = 1; y < (ydisplay-1); y++ )
 {
   for( x = 1; x < (xdisplay-1); x++ )
 {

    // On calcule l'orientation du pixel.
    dX = (image[ x + 1 + xdisplay * y ]>>16) - (image[ x - 1 + xdisplay * y ]>>16);
    dY = (image[ x + xdisplay * ( y + 1 ) ]>>16) - (image[ x + xdisplay * ( y - 1) ]>>16);

    // On rcupre le niveau d'illumination correspondant.
    // puis la couleur qui lui est associe.

    // On effectue un double changement de repre.
    dX = dX - ( lX - x );
    dY = dY - ( lY - y );

    // On clip les coordones.
    if( dX <= -128 || dX >= 128 ) dX = dY = -128;
    if( dY <= -128 || dY >= 128 ) dX = dY = -128;

    // On retourne dans un repre classique.
    dX += 128;
    dY += 128;

				
    // UPDTATE dans pixel
    if (image[x+xdisplay*y]==0) {
     ((int*)buffer->pixels)[ x + xdisplay*y] = palpaint[nEnvMap[ dX + 256*dY]];
    }
    else {

     if (image[x+xdisplay*y]==0xFFFFFF) {
      ((int*)buffer->pixels)[ x + xdisplay*y] = 0;
     }
     else {
      ((int*)buffer->pixels)[ x + xdisplay*y] = pal[nEnvMap[ dX + 256*dY]];
     }

    }

   }
  }

  SDL_UnlockSurface( buffer );

  //SDL_UpdateRects(buffer, 1, &rect);
  SDL_UpdateRect(buffer, 0, 0, 0, 0);


  lX = ((xdisplay/2) + (xdisplay/4)*cos(fTime += .05))*scalex;
  lY = ((ydisplay/2) + (ydisplay/4)*sin(fTime))*scaley;

  scalex=scalex+dscalex;
  scaley=scaley+dscaley;
  if(scalex>1.3)dscalex=0-dscalex;
  if(scalex<0.7)dscalex=0-dscalex;
  if(scaley>1.3)dscaley=0-dscaley;
  if(scaley<0.7)dscaley=0-dscaley;

  // Gestion des evenement, histoire qu'on se kasse
  // un jour de cette boucle.

  // Check for events
  while(SDL_PollEvent(&event))
 {  
   // Loop until there are no events left on the queue
   switch(event.type)
 {  
    case SDL_QUIT:  
         bQuit = 1;
         break;    
   }
  }


 }

 while(!bQuit);


 SDL_Quit();

 free(image);	
	
 return 0;
}
